# coding: UTF-8

from ctypes import c_char_p, c_int
from enum import IntEnum
from typing import Union

from . import _CtypesEnum


class ErrorCode(_CtypesEnum, IntEnum):
    NOTCOMPILED = ...
    NOTMOUNTED = ...
    NOTEXIST = ...
    NOTCREATED = ...
    SUBSYSNOTMOUNTED = ...
    NOTOWNER = ...
    MULTIMOUNTED = ...

    NOTALLOWED = ...
    MAXVALUESEXCEEDED = ...
    CONTROLLEREXISTS = ...
    VALUEEXISTS = ...
    INVAL = ...
    CONTROLLERCREATEFAILED = ...
    FAIL = ...
    NOTINITIALIZED = ...
    VALUENOTEXIST = ...

    OTHER = ...
    NOTEQUAL = ...
    CONTROLLERNOTEQUAL = ...

    PARSEFAIL = ...

    NORULES = ...
    MOUNTFAIL = ...

    EOF = ...

    CONFIGPARSEFAIL = ...
    NAMESPACEPATHS = ...
    NAMESPACECONTROLLER = ...
    MOUNTNAMESPACE = ...
    UNSUPP = ...
    CANTSETVALUE = ...

    NONEMPTY = ...


def cgroup_strerror(code: Union[c_int, int]) -> Union[c_char_p, bytes]: ...


def cgroup_get_last_errno() -> Union[c_int, int]: ...
